import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkPayLog, ThinkPayLogParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询支付日志
 */
export async function pageThinkPayLog(params: ThinkPayLogParam) {
  const res = await request.get<ApiResult<PageResult<ThinkPayLog>>>(
    THINK_API_URL + '/think/think-pay-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询支付日志列表
 */
export async function listThinkPayLog(params?: ThinkPayLogParam) {
  const res = await request.get<ApiResult<ThinkPayLog[]>>(
    THINK_API_URL + '/think/think-pay-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加支付日志
 */
export async function addThinkPayLog(data: ThinkPayLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-pay-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改支付日志
 */
export async function updateThinkPayLog(data: ThinkPayLog) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-pay-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除支付日志
 */
export async function removeThinkPayLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-pay-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除支付日志
 */
export async function removeBatchThinkPayLog(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-pay-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询支付日志
 */
export async function getThinkPayLog(id: number) {
  const res = await request.get<ApiResult<ThinkPayLog>>(
    THINK_API_URL + '/think/think-pay-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
